import { Component, OnInit, Input, Output, EventEmitter, ViewChild } from '@angular/core';
import { Ng2UmeditorService } from './ng2-umeditor.service';

declare var UM: any;
declare const window: any;
declare const document: any;

@Component({
  selector: 'app-ng2-umeditor',
  templateUrl: './ng2-umeditor.component.html',
  styleUrls: ['./ng2-umeditor.component.css'],
  providers: [Ng2UmeditorService]
})
export class Ng2UmeditorComponent implements OnInit {

  @ViewChild('umeditor') umeditor: any;
  @Input() config: any = { toolbar: ['undo redo | bold italic underline'] };
  @Input() content: string = "";
  @Input() id: string = "umeditor-" + new Date().getTime();
  @Output() onLoad: EventEmitter<any> = new EventEmitter<any>();
  @Output() onChange: EventEmitter<string> = new EventEmitter<string>();
  obj: any;

  constructor(private ng2UmeditorService: Ng2UmeditorService) { }
  ngOnInit() {
    this.umeditor.nativeElement.id = this.id;
    if (!!window.UM) {
      UM.delEditor(this.umeditor.nativeElement.id);
      this.init();
    }
    else {
      let path: Array<string> = new Array<any>();
      if (!window.jQuery) {
        this.ng2UmeditorService.loadScript(['/assets/umeditor/third-party/jquery.min.js']);
      }
      if (!window.etpl) {
        this.ng2UmeditorService.getScript('/assets/umeditor/third-party/template.min.js', () => {
          if (!window.UM) {
            this.ng2UmeditorService.getScript('/assets/umeditor/umeditor.config.js', () => {
              this.ng2UmeditorService.getScript('/assets/umeditor/umeditor.min.js', () => {
                this.init();
              });
            });
          }
        });
      }
    }
  }

  init() {
    this.obj = UM.getEditor(this.id, this.config);
    this.obj.ready(() => {
      this.obj.setContent(this.content);
      this.onLoad.emit(this.obj);
    });
    this.obj.addListener('contentChange', () => this.onChange.emit(this.obj.getContent()));
  }

}
