import { Injectable } from '@angular/core';

@Injectable()
export class Ng2UmeditorService {

    loadScript(path: Array<string>, success: Function = new Function()): void {
        let cx: number = path.length;
        path.forEach(src => {
            let node: any = document.createElement('script');
            node.type = 'text/javascript';
            node.src = src;
            node.charset = 'utf-8';
            node.onload = function () { if (--cx <= 0) success() }
            document.getElementsByTagName('head')[0].appendChild(node);
        })

    }

    getScript(src: string, onload: Function) {
        let node: any = document.createElement('script');
        node.type = 'text/javascript';
        node.src = src;
        node.charset = 'utf-8';
        node.onload = onload;
        document.getElementsByTagName('head')[0].appendChild(node);
    }

    loadCss(path: Array<string>): void {

        path.forEach(src => {
            let node: any = document.createElement('link');
            node.rel = 'stylesheet';
            node.type = 'text/css';
            node.href = src;
            document.getElementsByTagName('head')[0].appendChild(node);
        })
    }
}